---
title: OscillatorNode.OscillatorNode()
slug: Web/API/OscillatorNode/OscillatorNode
tags:
  - Audio
  - Constructor
  - Media
  - OscillatorNode
  - Reference
  - Web Audio
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p>The <strong><code>OscillatorNode()</code></strong> constructor of the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a> creates a new {{domxref("OscillatorNode")}} object which is an {{domxref("AudioNode")}} that represents a periodic waveform, like a sine wave, optionally setting the node's properties' values to match values in a specified object.</p>

<p>If the default values of the properties are acceptable, you can optionally use the {{domxref("AudioContext.createOscillator()")}} factory method instead.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>oscillatorNode</em> = new OscillatorNode(<em>context</em>, <em>options</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<p><em>Inherits parameters from the </em><em>{{domxref("AudioNodeOptions")}} dictionary</em>.</p>

<dl>
	<dt><code>context</code></dt>
	<dd>A reference to an {{domxref("AudioContext")}}.</dd>
	<dt><code>options</code> {{optional_inline}}</dt>
	<dd>An object whose properties specify the initial values for the oscillator node's properties. Any properties omitted from the object will take on the default value as documented.
	<dl>
		<dt><code>type</code></dt>
		<dd>The shape of the wave produced by the node. Valid values are '<code>sine</code>', '<code>square</code>', '<code>sawtooth</code>', '<code>triangle</code>' and '<code>custom</code>'. The default is '<code>sine</code>'.</dd>
		<dt><code>detune</code></dt>
		<dd>A detuning value (in cents) which will offset the <code>frequency</code> by the given amount. Its default is 0.</dd>
		<dt><code>frequency</code></dt>
		<dd>The frequency (in {{interwiki("wikipedia", "hertz")}}) of the periodic waveform. Its default is 440.</dd>
		<dt><code>periodicWave</code></dt>
		<dd>An arbitrary period waveform described by a {{domxref("PeriodicWave")}} object.</dd>
	</dl>
	</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("OscillatorNode")}} object instance.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Audio API','#dom-oscillatornode-oscillatornode','OscillatorNode()')}}</td>
			<td>{{Spec2('Web Audio API')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.OscillatorNode.OscillatorNode")}}</p>
</div>
